import nock from 'nock';
import { Anime } from '../src/Anime'

// tslint:disable:max-line-length
export const mockAnimeGenericResponse = { request_hash: "request:anime:b2748716b753dd75fb9dbc52a29f337e5df14bcb", request_cached: true, request_cache_expiry: 26882, mal_id: 100, url: "https://myanimelist.net/anime/100/Shin_Shirayuki-hime_Densetsu_Prétear", image_url: "https://cdn.myanimelist.net/images/anime/9/11709.jpg", trailer_url: null, title: "Shin Shirayuki-hime Densetsu Prétear", title_english: "Prétear: The New Legend of Snow White", title_japanese: "新白雪姫伝説プリーティア", title_synonyms: ["Shin Shirayuki-hime Densetsu Pretear"], type: "TV", source: "Manga", episodes: 13, status: "Finished Airing", airing: false, aired: { from: "2001-04-04T00:00:00+00:00", to: "2001-06-27T00:00:00+00:00", prop: { from: { day: 4, month: 4, year: 2001 }, to: { day: 27, month: 6, year: 2001 } }, string: "Apr 4, 2001 to Jun 27, 2001" }, duration: "23 min per ep", rating: "PG-13 - Teens 13 or older", score: 7.19, scored_by: 24909, rank: 2804, popularity: 2183, members: 54204, favorites: 461, synopsis: "Due to her father's remarriage, robust 16-year-old Himeno Awayuki moves into a large mansion with a beautiful garden—the quintessential dream house for any girl her age. However, much to Himeno's disappointment, her new stepfamily doesn't really seem to like her, as her stepmother often occupies herself with her father, her younger stepsister Mawata ignores her, and her other stepsister—the equally aged Mayune—tries to prank her at every opportunity. But Himeno doesn't have time to dwell into thoughts of hopelessness—her new life has now become involved with a group of seven magical boys known as the Leafe Knights, after they ask her to become a magical princess who can borrow their powers! Although Himeno accepts their request and becomes the Prétear, she feels doubtful in her abilities to protect the world and its Leafe, the source of energy for all life. Will Himeno be able to find happiness among her new family and also save the Earth from the enemy, the Princess of Disaster? [Written by MAL Rewrite]", background: null, premiered: "Spring 2001", broadcast: "Wednesdays at 18:30 (JST)", related: { Adaptation: [{ mal_id: 1248, type: "manga", name: "Shin Shirayuki-hime Densetsu Pretear", url: "https://myanimelist.net/manga/1248/Shin_Shirayuki-hime_Densetsu_Pretear" }] }, producers: [{ mal_id: 113, type: "anime", name: "Kadokawa Shoten", url: "https://myanimelist.net/anime/producer/113/Kadokawa_Shoten" }, { mal_id: 160, type: "anime", name: "Rondo Robe", url: "https://myanimelist.net/anime/producer/160/Rondo_Robe" }], licensors: [{ mal_id: 97, type: "anime", name: "ADV Films", url: "https://myanimelist.net/anime/producer/97/ADV_Films" }, { mal_id: 102, type: "anime", name: "Funimation", url: "https://myanimelist.net/anime/producer/102/Funimation" }], studios: [{ mal_id: 34, type: "anime", name: "Hal Film Maker", url: "https://myanimelist.net/anime/producer/34/Hal_Film_Maker" }], genres: [{ mal_id: 4, type: "anime", name: "Comedy", url: "https://myanimelist.net/anime/genre/4/Comedy" }, { mal_id: 8, type: "anime", name: "Drama", url: "https://myanimelist.net/anime/genre/8/Drama" }, { mal_id: 10, type: "anime", name: "Fantasy", url: "https://myanimelist.net/anime/genre/10/Fantasy" }, { mal_id: 16, type: "anime", name: "Magic", url: "https://myanimelist.net/anime/genre/16/Magic" }, { mal_id: 22, type: "anime", name: "Romance", url: "https://myanimelist.net/anime/genre/22/Romance" }, { mal_id: 25, type: "anime", name: "Shoujo", url: "https://myanimelist.net/anime/genre/25/Shoujo" }, { mal_id: 31, type: "anime", name: "Super Power", url: "https://myanimelist.net/anime/genre/31/Super_Power" }], opening_themes: ["\"White destiny\" by Ishida Yoko"], ending_themes: ["\"Lucky Star\" by Yoshida Sayuri"] }

describe("get anime by id", () => {
    it("should return anime with generic information", async () => {
        nock("https://api.jikan.moe/v3/").get('/anime/100').reply(200, mockAnimeGenericResponse);

        const anime = new Anime(100);
        const result = await anime.get();
        expect(result).toStrictEqual(mockAnimeGenericResponse);
    });
});

